;;; Post a note periodically.

(if (< (length *argv*) 4)
    (begin (display "Usage: xmtscm alarm.scm seconds string")
	   (newline)
	   (quit 1)))

(require 'xmts)

(xmts:run-app 

 "postit"
	
 (lambda (top)
   (xmts:put-line-resources top 
			    "*FontList: *helvetica-bold-r-normal-*-*-240-*"
			    "*Foreground: firebrick"
			    "*Background: wheat"
			    "*layoutMarginWidth: 0"
			    "*layoutMarginHeight: 0")
   (xmts:set-title top "Post-It")
   (let* ((layout  (xt:create-managed-widget "main" xmt:layout top))
	  (label   (xt:create-managed-widget "label" xm:label layout))
	  (timeout (* 1000 (string->number (list-ref *argv* 1))))
	  (str     (list-ref *argv* 2)))
     (if str (xmts:label-set-string label str))
     (xt:add-event-handler label x:button-press-mask 0
			   (lambda (widget event)
			     (xt:unmap-widget top)
			     (xt:app-add-time-out 
			      label timeout 
			      (lambda ()
				(xt:map-widget top)
				(xmts:bell top 50)))))))
)
     
					      
    
