;;; HTML Widget Demo

(require 'xmts)
(require 'xmtconst)
(require 'htmlconst)

;;; Thanks to Aubrey Jaffer for the following routine.
(define read-file
  (let ((pv (program-vicinity)))
    (lambda (filename)
      (let ((port (open-file filename "rb"))
            (file-name filename))
        (cond ((not port)
               (set! file-name (in-vicinity pv filename))
               (set! port (open-file file-name "rb"))))
        (cond
         ((not port)
          (slib:error "couldn't find: " filename "or" file-name))
         (else
          (let* ((sizeinc 1024)
                 (result (make-uniform-array #\! sizeinc)))
            (let loop ((mem result))
              (let ((len (uniform-array-read! mem port))
                    (cursize (car (array-dimensions result))))
                (cond ((= (car (array-dimensions mem)) len)
                       (vector-set-length! result (+ sizeinc cursize))
                       (loop (make-shared-array result
                                                (lambda (i) (+ i cursize))
                                                sizeinc)))
                      (else (vector-set-length! result
                                                (+ cursize len (- sizeinc)))
                            result)))))))))))

(define (set-html-text widget data)
  (let ((html-widget (car data)) 
	(text-widget (cadr data))
	(filename    (if (> (length data) 2) (caddr data) #f)))
    (xt:set-values html-widget "text"
		   (read-file (if filename
				  filename
				  (xm:text-get-string text-widget))))
    (if filename
	(xm:text-set-string text-widget filename))))
;    (display "All hypertext references are as follows:\n")
;    (write (html:get-hrefs html-widget))
;    (newline)))

(xmts:run-app
 "html"
 (lambda (top)
   (let* ((lay  (xt:create-managed-widget "lay" xmt:layout top))
	  (file (xt:create-managed-widget "file" xmt:input-field lay))
	  (html (xt:create-managed-widget "html" html lay)))
     (xt:add-callback file xmt:n-input-callback set-html-text 
		      (list html file))
     (xt:add-callback html wb:n-anchor-callback
		      (lambda (widget c d) (write d) (newline))
		      #f)
     ;(write *argv*) (newline)
     (if (> (length *argv*) 1)
	 (set-html-text file (list html file (cadr *argv*)))))))
		      
