/*
 * $Header: /home/tomkwong/src/xmtscm/RCS/html.c,v 1.1 1995/12/05 23:05:34 tomkwong Exp $
 *
 * HTML Widget extension to SCM.
 * Copyright 1995 Thomas Kwong
 *
 */
#include "HTML.h"
#include "scm.h"
#include "x.h"
#include "xt.h"

xt_widget_class_t html_widget_classes[] = {
  {"html",                &htmlWidgetClass},
};

static char s_html_get_text[] = "html:get-text";
SCM html_get_text(sw, pretty)
SCM sw, pretty;
{
  char *txt;

  ASSERT(NIMP(sw) && WIDGETP(sw), sw, ARG1, s_html_get_text);
  ASSERT(INUMP(pretty) && INUM(pretty)>=0 && INUM(pretty)<=2, pretty, 
	 ARG2, s_html_get_text);
#ifdef OLD_MOSAIC		/* before version 2.7 */
  txt = HTMLGetText(WIDGET(sw), INUM(pretty));
#else
  txt = HTMLGetText(WIDGET(sw), INUM(pretty), NULL, NULL);
#endif
  return makfrom0str(txt);
}

static char s_html_get_hrefs[] = "html:get-hrefs";
SCM html_get_hrefs(sw)
SCM sw;
{
  char **hrefs;
  int i, num;
  SCM vec, *v;

  ASSERT(NIMP(sw) && WIDGETP(sw), sw, ARG1, s_html_get_hrefs);
  hrefs = HTMLGetHRefs(WIDGET(sw), &num);
  vec = make_vector(MAKINUM(num), BOOL_F); v = VELTS(vec);
  for (i = 0; i < num; i++) {
    v[i] = makfrom0str(hrefs[i]);
    free(hrefs[i]);
  }
  free(hrefs);
  
  return vec;
}

iproc html_subr2s[] = {
  {s_html_get_text, html_get_text},
  {0,0}
};

iproc html_subr1s[] = {
  {s_html_get_hrefs, html_get_hrefs},
  {0,0}
};

void init_html()
{
  init_iprocs(html_subr1s,  tc7_subr_1);
  init_iprocs(html_subr2s,  tc7_subr_2);
  xt_init_widget_classes(
    html_widget_classes,
    XtNumber(html_widget_classes),
    "*html-motif-widget-classes*");
  add_feature("html");
#ifdef XMT
  XmtRegisterWidgetClass("HTML", htmlWidgetClass);
#endif
}

