;;; Test multi app

(require 'xmts)

; Make a new toplevel shell widget.
; Catch WM_DELETE_WINDOW message; if no more toplevel widget,
; quit the program.
(define make-main-window
  (let ((count 0))
    (lambda (widget)
      (let ((top (xmts:create-top-level-shell widget "App")))
	(xmts:put-line-resources top
				 "*App.xmtChildren: XmPushButton Hello;"
				 "*XmPushButton.shadowThickness: 5")
	(let ((w (xmts:create-query-children top '((b . "Hello")))))
	  (xmts:add-activate (w 'b) (lambda (w) (make-main-window widget))))
	(xt:popup top 0)
	(set! count (+ count 1))
	(xmt:add-delete-callback top xm:destroy
				 (lambda (widget client-data)
				   (set! count (- count 1))
				   (if (= count 0)
				       (quit 0)))
				 #f)))))

(xmts:run-multi-app
 "multitop"
 (lambda (top) (make-main-window top)))


