;; password.scm
;;
;; Give a text widget the behavior of accepting a password.
;; Returns a closure that returns the unseen password for this widget.
;;
(define (xmts:make-password-text widget)

  (define word "")

  (define (modify-callback widget client data)
    (cond ((< (xm:text:start-pos data)          ; backspace?
	      (xm:text:curr-insert data))
	   (if (> (string-length word) 0)
	       (set! word (substring word 0 (- (string-length word) 1))))
	   #t)
	  ((> (string-length (xm:text:text data)) 1) ; don't paste
	   #f)
	  
	  (else
	   (set! word (string-append word (xm:text:text data)))
	   "*")))

  (define (motion-callback widget client data)
    (= (xm:text:new-insert data) (xm:text-get-last-position widget)))

  (xmts:add-modify widget modify-callback #f)
  (xmts:add-motion widget motion-callback #f)
  (lambda () word))

