;;; Positionable List

(require 'xmts)
(require 'sort)

(xmts:run-app 

 "plist"

 (lambda (top)

   (xmts:put-line-resources 
    top
    "*background: gray75"
    "*layoutMarginWidth: 0"
    "*fontList: *new century schoolbook-medium-r-normal-*-*-180-*"
    "*list.visibleItemCount: 6"
    "*list.selectionPolicy: XmBROWSE_SELECT"
    "*scale.showValue: True"
    "*scale.processingDirection: XmMAX_ON_BOTTOM")

   (let* ((layout (xt:create-managed-widget "layout" xmt:layout top
					    xmt:n-layout 
					    "Row {list Fixed scale}"))
	  (listw  (xt:create-managed-widget "list" xm:list layout))
	  (scalew (xt:create-managed-widget "scale"  xm:scale layout)))

     (let ((data #("1" "2" "3" "4" "5" "6")))
       (xmts:list-set-items-ascii listw data)
       (xt:set-values scalew
		      xm:n-minimum    1
		      xm:n-maximum    (vector-length data)
		      xm:n-value      1))

     (xmts:add-browse listw 
		      (lambda (w c d)
			(xm:scale-set-value scalew 
					    (xm:list:item-position d)))
		      #t)

     (let ((move (lambda (w from to)
		   (let* ((items (xmts:list-get-items w))
			  (fitem (vector-ref items (- from 1)))
			  (titem (vector-ref items (- to 1)))
			  (ftable (xm:vector->xmstringtable (vector fitem)))
			  (ttable (xm:vector->xmstringtable (vector titem))))
		     (xm:list-replace-items-pos w ftable to)
		     (xm:list-replace-items-pos w ttable from))))
	   (mmove (lambda (w from to)
		    (let* ((items (xmts:list-get-items w))
			   (fitem (vector-ref items (- from 1)))
			   (titem (vector-ref items (- to 1))))
		      (xm:list-delete-items-pos w 1 from)
		      (xm:list-add-item w titem from)
		      (xm:list-delete-items-pos w 1 to)
		      (xm:list-add-item w fitem to)))))
		 

       (xt:add-callback scalew
			xm:n-drag-callback
			(lambda (w c d)
			  (let ((pos (xm:list-get-selected-pos listw)))
			    (if (not (null? pos))
				(mmove listw (car pos) 
				      (xm:scale:value d)))))
			#t))

)))