(require 'xmts)
(require 'htmlconst)

(define read-file
  (let ((pv (program-vicinity)))
    (lambda (filename)
      (let ((port (open-file filename "rb"))
            (file-name filename))
        (cond ((not port)
               (set! file-name (in-vicinity pv filename))
               (set! port (open-file file-name "rb"))))
        (cond
         ((not port)
          (slib:error "couldn't find: " filename "or" file-name))
         (else
          (let* ((sizeinc 1024)
                 (result (make-uniform-array #\! sizeinc)))
            (let loop ((mem result))
              (let ((len (uniform-array-read! mem port))
                    (cursize (car (array-dimensions result))))
                (cond ((= (car (array-dimensions mem)) len)
                       (vector-set-length! result (+ sizeinc cursize))
                       (loop (make-shared-array result
                                                (lambda (i) (+ i cursize))
                                                sizeinc)))
                      (else (vector-set-length! result
                                                (+ cursize len (- sizeinc)))
                            result)))))))))))

(xmts:run-app
 "try"
 (lambda (top)
   (let* ((h (xt:create-managed-widget "html" html top)))
     (xt:set-values h wb:n-text (read-file "example.html"))
     (xt:add-callback h wb:n-anchor-callback
		      (lambda (w c d) (write d) (newline))
		      #t)
     )))
