#include <sys/utsname.h>
#include <pwd.h>

char *myhost(void)
{
    static char name[64];
    struct utsname un;

    if (uname(&un) >= 0)
	strcpy(name, un.nodename);
    else
	strcpy(name, "");

    return name;
}

char *myname(void)
{
    static char name[64];
    struct passwd *pwd = getpwuid(getuid());
    
    if (pwd && pwd->pw_name)
	strcpy(name, pwd->pw_name);
    else
	strcpy(name, "");

    return name;
}

char *myrealname(void)
{
    static char name[64];
    struct passwd *pwd = getpwuid(getuid());
    
    if (pwd && pwd->pw_gecos)
	strcpy(name, pwd->pw_gecos);
    else
	strcpy(name, "");

    return name;
}

#ifdef TEST
int main()
{
    printf("host=[%s], user=[%s], name=[%s]\n", 
	   myhost(), myname(), myrealname());
    return 0;
}

#endif
