/*
 * $Header: /home/tomkwong/src/xmtscm/RCS/xm.c,v 1.1 1995/12/05 23:04:41 tomkwong Exp $
 *
 * Author: Larry Campbell (campbell@world.std.com)
 *
 * Copyright 1992 by The Boston Software Works, Inc.
 * Permission to use for any purpose whatsoever granted, as long
 * as this copyright notice remains intact.  Please send bug fixes
 * or enhancements to the above email address.
 *
 * Class and function definitions for scm interface to Motif toolkit
 *
 * Modified by Thomas Kwong (tomkwong@wilshire.com) 11/21/1995.
 */

#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/StringDefs.h>
#include <Xm/Xm.h>
#include <Xm/ArrowB.h>
#include <Xm/ArrowBG.h>
#include <Xm/BulletinB.h>
#include <Xm/CascadeB.h>
#include <Xm/CascadeBG.h>
#include <Xm/DialogS.h>
#include <Xm/DrawingA.h>
#include <Xm/DrawnB.h>
#include <Xm/FileSB.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/LabelG.h>
#include <Xm/List.h>
#include <Xm/MainW.h>
#include <Xm/MenuShell.h>
#include <Xm/MessageB.h>
#include <Xm/PanedW.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h>
#include <Xm/Scale.h>
#include <Xm/ScrollBar.h>
#include <Xm/ScrolledW.h>
#include <Xm/SelectioB.h>
#include <Xm/Separator.h>
#include <Xm/SeparatoG.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/ToggleB.h>
#include <Xm/ToggleBG.h>

#include "scm.h"
#include "x.h"
#include "xt.h"

static char	s_xm_create_popup_menu[]	= "xm:create-popup-menu";
static char	s_xm_create_pulldown_menu[]	= "xm:create-pulldown-menu";
static char	s_xm_list_delete_item[]		= "xm:list-delete-item";
static char	s_xm_list_deselect_all_items[]	= "xm:list-deselect-all-items";
static char	s_xm_menu_position[]		= "xm:menu-position";
static char	s_xm_string_create[]		= "xm:string-create";
static char	s_xm_string_get_first_segment[]	= "xm:string-get-first-segment";
static char	s_xm_text_get_string[]		= "xm:text-get-string";
static char	s_xm_vector_to_xmstringtable[]	= "xm:vector->xmstringtable";
static char	s_xm_xmstringp[]		= "xm:xmstring?";
static char	s_xm_xmstringtablep[]		= "xm:xmstringtable?";
static char	s_xm_xmstringtable_to_vector[]	= "xm:xmstringtable->vector";
static char 	s_xm_process_traversal[]	= "xm:process-traversal";
#ifdef SUPER_MOTIF
static char     s_xm_list_add_item[]            = "xm:list-add-item";
static char     s_xm_list_add_items[]           = "xm:list-add-items";
static char     s_xm_list_delete_all_items[]    = "xm:list-delete-all-items";
static char     s_xm_list_delete_items_pos[]    = "xm:list-delete-items-pos";
static char 	s_xm_list_get_selected_pos[]	= "xm:list-get-selected-pos";
static char     s_xm_list_replace_items_pos[]   = "xm:list-replace-items-pos";
static char     s_xm_list_select_item[]         = "xm:list-select-item";
static char     s_xm_list_select_pos[]          = "xm:list-select-pos";
static char     s_xm_text_set_string[]          = "xm:text-set-string";
static char     s_xm_x_text_get_position[]        = "xm:x-text-get-position";
static char     s_xm_text_insert[]              = "xm:text-insert";
static char     s_xm_text_do_position[]         = "xm:x-text-do-position";
static char     s_xm_text_replace[]             = "xm:text-replace";
static char     s_xm_text_find_string[]         = "xm:text-find-string";
static char     s_xm_get_pixmap[]               = "xm:get-pixmap";
static char     s_xm_get_pixmap_by_depth[]      = "xm:get-pixmap-by-depth";
static char     s_xm_destroy_pixmap[]           = "xm:destroy-pixmap";
#endif

xt_widget_class_t xm_widget_classes[] = {
  { "xm:arrow-button",		&xmArrowButtonWidgetClass},
  { "xm:arrow-button-gadget",	&xmArrowButtonGadgetClass},
  { "xm:bulletin-board",	&xmBulletinBoardWidgetClass},
  { "xm:cascade-button",	&xmCascadeButtonWidgetClass},
  { "xm:cascade-button-gadget",	&xmCascadeButtonGadgetClass},
  { "xm:dialog-shell",		&xmDialogShellWidgetClass},
  { "xm:drawing-area",		&xmDrawingAreaWidgetClass},
  { "xm:drawn-button",		&xmDrawnButtonWidgetClass},
  { "xm:file-selection-box",	&xmFileSelectionBoxWidgetClass},
  { "xm:form",			&xmFormWidgetClass},
  { "xm:frame",			&xmFrameWidgetClass},
  { "xm:gadget",		&xmGadgetClass},
  { "xm:label",			&xmLabelWidgetClass},
  { "xm:label-gadget",		&xmLabelGadgetClass},
  { "xm:list",			&xmListWidgetClass},
  { "xm:main-window",		&xmMainWindowWidgetClass},
  { "xm:menu-shell",		&xmMenuShellWidgetClass},
  { "xm:message-box",		&xmMessageBoxWidgetClass},
  { "xm:paned-window",		&xmPanedWindowWidgetClass},
  { "xm:push-button",		&xmPushButtonWidgetClass},
  { "xm:push-button-gadget",	&xmPushButtonGadgetClass},
  { "xm:row-column",		&xmRowColumnWidgetClass},
  { "xm:scale",			&xmScaleWidgetClass},
  { "xm:scroll-bar",		&xmScrollBarWidgetClass},
  { "xm:scrolled-window",	&xmScrolledWindowWidgetClass},
  { "xm:selection-box",		&xmSelectionBoxWidgetClass},
  { "xm:separator",		&xmSeparatorWidgetClass},
  { "xm:separator-gadget",	&xmSeparatorGadgetClass},
  { "xm:text",			&xmTextWidgetClass},
  { "xm:text-field",		&xmTextFieldWidgetClass},
  { "xm:toggle-button",		&xmToggleButtonWidgetClass},
  { "xm:toggle-button-gadget",	&xmToggleButtonGadgetClass},
  { "xm:vendor-shell",		&vendorShellWidgetClass},
};

static XSymMap xm_symbols[] = {
  {"xm:font-is-font", XmFONT_IS_FONT},
  {"xm:font-is-fontset", XmFONT_IS_FONTSET},
  {"xm:string-direction-l-to-r", XmSTRING_DIRECTION_L_TO_R},
  {"xm:string-direction-r-to-l", XmSTRING_DIRECTION_R_TO_L},
  {"xm:string-direction-default", XmSTRING_DIRECTION_DEFAULT},
  {"xm:string-component-unknown", XmSTRING_COMPONENT_UNKNOWN},
  {"xm:string-component-charset", XmSTRING_COMPONENT_CHARSET},
  {"xm:string-component-text", XmSTRING_COMPONENT_TEXT},
  {"xm:string-component-direction", XmSTRING_COMPONENT_DIRECTION},
  {"xm:string-component-separator", XmSTRING_COMPONENT_SEPARATOR},
  {"xm:string-component-locale-text", XmSTRING_COMPONENT_LOCALE_TEXT},
  {"xm:string-component-end", XmSTRING_COMPONENT_END},
  {"xm:string-component-user-begin", XmSTRING_COMPONENT_USER_BEGIN},
  {"xm:string-component-user-end", XmSTRING_COMPONENT_USER_END},
  {"xm:change-all", XmCHANGE_ALL},
  {"xm:change-none", XmCHANGE_NONE},
  {"xm:change-width", XmCHANGE_WIDTH},
  {"xm:change-height", XmCHANGE_HEIGHT},
  {"xm:pixels", XmPIXELS},
  {"xm:100th-millimeters", Xm100TH_MILLIMETERS},
  {"xm:1000th-inches", Xm1000TH_INCHES},
  {"xm:100th-points", Xm100TH_POINTS},
  {"xm:100th-font-units", Xm100TH_FONT_UNITS},
  {"xm:destroy", XmDESTROY},
  {"xm:unmap", XmUNMAP},
  {"xm:do-nothing", XmDO_NOTHING},
  {"xm:explicit", XmEXPLICIT},
  {"xm:pointer", XmPOINTER},
  {"xm:none", XmNONE},
  {"xm:tab-group", XmTAB_GROUP},
  {"xm:sticky-tab-group", XmSTICKY_TAB_GROUP},
  {"xm:exclusive-tab-group", XmEXCLUSIVE_TAB_GROUP},
  {"xm:dynamic-default-tab-group", XmDYNAMIC_DEFAULT_TAB_GROUP},
  {"xm:bell", XmBELL},
  {"xm:no-orientation", XmNO_ORIENTATION},
  {"xm:vertical", XmVERTICAL},
  {"xm:horizontal", XmHORIZONTAL},
  {"xm:work-area", XmWORK_AREA},
  {"xm:menu-bar", XmMENU_BAR},
  {"xm:menu-pulldown", XmMENU_PULLDOWN},
  {"xm:menu-popup", XmMENU_POPUP},
  {"xm:menu-option", XmMENU_OPTION},
  {"xm:no-packing", XmNO_PACKING},
  {"xm:pack-tight", XmPACK_TIGHT},
  {"xm:pack-column", XmPACK_COLUMN},
  {"xm:pack-none", XmPACK_NONE},
  {"xm:alignment-baseline-top", XmALIGNMENT_BASELINE_TOP},
  {"xm:alignment-center", XmALIGNMENT_CENTER},
  {"xm:alignment-baseline-bottom", XmALIGNMENT_BASELINE_BOTTOM},
  {"xm:alignment-contents-top", XmALIGNMENT_CONTENTS_TOP},
  {"xm:alignment-contents-bottom", XmALIGNMENT_CONTENTS_BOTTOM},
  {"xm:alignment-beginning", XmALIGNMENT_BEGINNING},
  {"xm:alignment-end", XmALIGNMENT_END},
  {"xm:alignment-widget-top", XmALIGNMENT_WIDGET_TOP},
  {"xm:alignment-widget-bottom", XmALIGNMENT_WIDGET_BOTTOM},
  {"xm:tear-off-enabled", XmTEAR_OFF_ENABLED},
  {"xm:tear-off-disabled", XmTEAR_OFF_DISABLED},
  {"xm:unpost", XmUNPOST},
  {"xm:unpost-and-replay", XmUNPOST_AND_REPLAY},
  {"xm:last-position", XmLAST_POSITION},
  {"xm:first-position", XmFIRST_POSITION},
  {"xm:frame-generic-child", XmFRAME_GENERIC_CHILD},
  {"xm:frame-workarea-child", XmFRAME_WORKAREA_CHILD},
  {"xm:frame-title-child", XmFRAME_TITLE_CHILD},
  {"xm:n-of-many", XmN_OF_MANY},
  {"xm:one-of-many", XmONE_OF_MANY},
  {"xm:attach-none", XmATTACH_NONE},
  {"xm:attach-form", XmATTACH_FORM},
  {"xm:attach-opposite-form", XmATTACH_OPPOSITE_FORM},
  {"xm:attach-widget", XmATTACH_WIDGET},
  {"xm:attach-opposite-widget", XmATTACH_OPPOSITE_WIDGET},
  {"xm:attach-position", XmATTACH_POSITION},
  {"xm:attach-self", XmATTACH_SELF},
  {"xm:resize-none", XmRESIZE_NONE},
  {"xm:resize-grow", XmRESIZE_GROW},
  {"xm:resize-any", XmRESIZE_ANY},
  {"xm:cr-help", XmCR_HELP},
  {"xm:cr-value-changed", XmCR_VALUE_CHANGED},
  {"xm:cr-increment", XmCR_INCREMENT},
  {"xm:cr-decrement", XmCR_DECREMENT},
  {"xm:cr-page-increment", XmCR_PAGE_INCREMENT},
  {"xm:cr-page-decrement", XmCR_PAGE_DECREMENT},
  {"xm:cr-to-top", XmCR_TO_TOP},
  {"xm:cr-to-bottom", XmCR_TO_BOTTOM},
  {"xm:cr-drag", XmCR_DRAG},
  {"xm:cr-activate", XmCR_ACTIVATE},
  {"xm:cr-arm", XmCR_ARM},
  {"xm:cr-disarm", XmCR_DISARM},
  {"xm:cr-map", XmCR_MAP},
  {"xm:cr-unmap", XmCR_UNMAP},
  {"xm:cr-focus", XmCR_FOCUS},
  {"xm:cr-losing-focus", XmCR_LOSING_FOCUS},
  {"xm:cr-modifying-text-value", XmCR_MODIFYING_TEXT_VALUE},
  {"xm:cr-moving-insert-cursor", XmCR_MOVING_INSERT_CURSOR},
  {"xm:cr-execute", XmCR_EXECUTE},
  {"xm:cr-single-select", XmCR_SINGLE_SELECT},
  {"xm:cr-multiple-select", XmCR_MULTIPLE_SELECT},
  {"xm:cr-extended-select", XmCR_EXTENDED_SELECT},
  {"xm:cr-browse-select", XmCR_BROWSE_SELECT},
  {"xm:cr-default-action", XmCR_DEFAULT_ACTION},
  {"xm:cr-clipboard-data-request", XmCR_CLIPBOARD_DATA_REQUEST},
  {"xm:cr-clipboard-data-delete", XmCR_CLIPBOARD_DATA_DELETE},
  {"xm:cr-cascading", XmCR_CASCADING},
  {"xm:cr-ok", XmCR_OK},
  {"xm:cr-cancel", XmCR_CANCEL},
  {"xm:cr-apply", XmCR_APPLY},
  {"xm:cr-no-match", XmCR_NO_MATCH},
  {"xm:cr-command-entered", XmCR_COMMAND_ENTERED},
  {"xm:cr-command-changed", XmCR_COMMAND_CHANGED},
  {"xm:cr-expose", XmCR_EXPOSE},
  {"xm:cr-resize", XmCR_RESIZE},
  {"xm:cr-input", XmCR_INPUT},
  {"xm:cr-gain-primary", XmCR_GAIN_PRIMARY},
  {"xm:cr-lose-primary", XmCR_LOSE_PRIMARY},
  {"xm:cr-create", XmCR_CREATE},
  {"xm:cr-tear-off-activate", XmCR_TEAR_OFF_ACTIVATE},
  {"xm:cr-tear-off-deactivate", XmCR_TEAR_OFF_DEACTIVATE},
  {"xm:cr-obscured-traversal", XmCR_OBSCURED_TRAVERSAL},
  {"xm:cr-protocols", XmCR_PROTOCOLS},
  {"xm:multiclick-discard", XmMULTICLICK_DISCARD},
  {"xm:multiclick-keep", XmMULTICLICK_KEEP},
  {"xm:shadow-in", XmSHADOW_IN},
  {"xm:shadow-out", XmSHADOW_OUT},
  {"xm:arrow-up", XmARROW_UP},
  {"xm:arrow-down", XmARROW_DOWN},
  {"xm:arrow-left", XmARROW_LEFT},
  {"xm:arrow-right", XmARROW_RIGHT},
  {"xm:no-line", XmNO_LINE},
  {"xm:single-line", XmSINGLE_LINE},
  {"xm:double-line", XmDOUBLE_LINE},
  {"xm:single-dashed-line", XmSINGLE_DASHED_LINE},
  {"xm:double-dashed-line", XmDOUBLE_DASHED_LINE},
  {"xm:pixmap", XmPIXMAP},
  {"xm:string", XmSTRING},
  {"xm:window", XmWINDOW},
  {"xm:cursor", XmCURSOR},
  {"xm:max-on-top", XmMAX_ON_TOP},
  {"xm:max-on-bottom", XmMAX_ON_BOTTOM},
  {"xm:max-on-left", XmMAX_ON_LEFT},
  {"xm:max-on-right", XmMAX_ON_RIGHT},
  {"xm:single-select", XmSINGLE_SELECT},
  {"xm:multiple-select", XmMULTIPLE_SELECT},
  {"xm:extended-select", XmEXTENDED_SELECT},
  {"xm:browse-select", XmBROWSE_SELECT},
  {"xm:static", XmSTATIC},
  {"xm:dynamic", XmDYNAMIC},
  {"xm:variable", XmVARIABLE},
  {"xm:constant", XmCONSTANT},
  {"xm:resize-if-possible", XmRESIZE_IF_POSSIBLE},
  {"xm:automatic", XmAUTOMATIC},
  {"xm:application-defined", XmAPPLICATION_DEFINED},
  {"xm:as-needed", XmAS_NEEDED},
  {"xm:top-left", XmTOP_LEFT},
  {"xm:bottom-left", XmBOTTOM_LEFT},
  {"xm:top-right", XmTOP_RIGHT},
  {"xm:bottom-right", XmBOTTOM_RIGHT},
  {"xm:command-above-workspace", XmCOMMAND_ABOVE_WORKSPACE},
  {"xm:command-below-workspace", XmCOMMAND_BELOW_WORKSPACE},
  {"xm:multi-line-edit", XmMULTI_LINE_EDIT},
  {"xm:single-line-edit", XmSINGLE_LINE_EDIT},
  {"xm:text-forward", XmTEXT_FORWARD},
  {"xm:text-backward", XmTEXT_BACKWARD},
  {"xm:select-position", XmSELECT_POSITION},
  {"xm:select-whitespace", XmSELECT_WHITESPACE},
  {"xm:select-word", XmSELECT_WORD},
  {"xm:select-line", XmSELECT_LINE},
  {"xm:select-all", XmSELECT_ALL},
  {"xm:select-paragraph", XmSELECT_PARAGRAPH},
  {"xm:highlight-normal", XmHIGHLIGHT_NORMAL},
  {"xm:highlight-selected", XmHIGHLIGHT_SELECTED},
  {"xm:highlight-secondary-selected", XmHIGHLIGHT_SECONDARY_SELECTED},
  {"xm:copy-failed", XmCOPY_FAILED},
  {"xm:copy-succeeded", XmCOPY_SUCCEEDED},
  {"xm:copy-truncated", XmCOPY_TRUNCATED},
  {"xm:dialog-none", XmDIALOG_NONE},
  {"xm:dialog-apply-button", XmDIALOG_APPLY_BUTTON},
  {"xm:dialog-cancel-button", XmDIALOG_CANCEL_BUTTON},
  {"xm:dialog-default-button", XmDIALOG_DEFAULT_BUTTON},
  {"xm:dialog-ok-button", XmDIALOG_OK_BUTTON},
  {"xm:dialog-filter-label", XmDIALOG_FILTER_LABEL},
  {"xm:dialog-filter-text", XmDIALOG_FILTER_TEXT},
  {"xm:dialog-help-button", XmDIALOG_HELP_BUTTON},
  {"xm:dialog-list", XmDIALOG_LIST},
  {"xm:dialog-list-label", XmDIALOG_LIST_LABEL},
  {"xm:dialog-message-label", XmDIALOG_MESSAGE_LABEL},
  {"xm:dialog-selection-label", XmDIALOG_SELECTION_LABEL},
  {"xm:dialog-symbol-label", XmDIALOG_SYMBOL_LABEL},
  {"xm:dialog-text", XmDIALOG_TEXT},
  {"xm:dialog-separator", XmDIALOG_SEPARATOR},
  {"xm:dialog-dir-list", XmDIALOG_DIR_LIST},
  {"xm:dialog-dir-list-label", XmDIALOG_DIR_LIST_LABEL},
  {"xm:dialog-history-list", XmDIALOG_HISTORY_LIST},
  {"xm:dialog-prompt-label", XmDIALOG_PROMPT_LABEL},
  {"xm:dialog-value-text", XmDIALOG_VALUE_TEXT},
  {"xm:dialog-command-text", XmDIALOG_COMMAND_TEXT},
  {"xm:dialog-file-list", XmDIALOG_FILE_LIST},
  {"xm:dialog-file-list-label", XmDIALOG_FILE_LIST_LABEL},
  {"xm:dialog-modeless", XmDIALOG_MODELESS},
  {"xm:dialog-primary-application-modal", XmDIALOG_PRIMARY_APPLICATION_MODAL},
  {"xm:dialog-full-application-modal", XmDIALOG_FULL_APPLICATION_MODAL},
  {"xm:dialog-system-modal", XmDIALOG_SYSTEM_MODAL},
  {"xm:place-top", XmPLACE_TOP},
  {"xm:place-above-selection", XmPLACE_ABOVE_SELECTION},
  {"xm:place-below-selection", XmPLACE_BELOW_SELECTION},
  {"xm:file-directory", XmFILE_DIRECTORY},
  {"xm:file-regular", XmFILE_REGULAR},
  {"xm:file-any-type", XmFILE_ANY_TYPE},
  {"xm:dialog-work-area", XmDIALOG_WORK_AREA},
  {"xm:dialog-prompt", XmDIALOG_PROMPT},
  {"xm:dialog-selection", XmDIALOG_SELECTION},
  {"xm:dialog-command", XmDIALOG_COMMAND},
  {"xm:dialog-file-selection", XmDIALOG_FILE_SELECTION},
  {"xm:dialog-template", XmDIALOG_TEMPLATE},
  {"xm:dialog-error", XmDIALOG_ERROR},
  {"xm:dialog-information", XmDIALOG_INFORMATION},
  {"xm:dialog-message", XmDIALOG_MESSAGE},
  {"xm:dialog-question", XmDIALOG_QUESTION},
  {"xm:dialog-warning", XmDIALOG_WARNING},
  {"xm:dialog-working", XmDIALOG_WORKING},
  {"xm:visibility-unobscured", XmVISIBILITY_UNOBSCURED},
  {"xm:visibility-partially-obscured", XmVISIBILITY_PARTIALLY_OBSCURED},
  {"xm:visibility-fully-obscured", XmVISIBILITY_FULLY_OBSCURED},
  {"xm:traverse-current", XmTRAVERSE_CURRENT},
  {"xm:traverse-next", XmTRAVERSE_NEXT},
  {"xm:traverse-prev", XmTRAVERSE_PREV},
  {"xm:traverse-home", XmTRAVERSE_HOME},
  {"xm:traverse-next-tab-group", XmTRAVERSE_NEXT_TAB_GROUP},
  {"xm:traverse-prev-tab-group", XmTRAVERSE_PREV_TAB_GROUP},
  {"xm:traverse-up", XmTRAVERSE_UP},
  {"xm:traverse-down", XmTRAVERSE_DOWN},
  {"xm:traverse-left", XmTRAVERSE_LEFT},
  {"xm:traverse-right", XmTRAVERSE_RIGHT},
  {0,0}
};

extern void xt__make_arglist();

static sizet xm_free_xmstring();
static sizet xm_free_xmstringtable();

/*
 * Scheme types defined in this module
 */

#define XM_SMOBS							\
XX(xmstring,		mark_no_further,	xm_free_xmstring)	\
XX(xmstringtable,	mark_no_further,	xm_free_xmstringtable)

#undef XX
#define XX(name, mark, free)			\
long TOKEN_PASTE(tc16_,name);			\
static int TOKEN_PASTE(print_,name)();		\
static smobfuns TOKEN_PASTE(smob,name) =	\
	{ mark, free, TOKEN_PASTE(print_,name) };

XM_SMOBS

SCM xm_process_traversal(w, dir)
SCM w, dir;
{
  ASSERT(NIMP(w) && WIDGETP(w), w, ARG1, s_xm_process_traversal);
  ASSERT(INUMP(dir), dir, ARG1, s_xm_process_traversal);
  XmProcessTraversal(WIDGET(w), INUM(dir));
}

SCM make_xmstring()
{
  SCM s;
  NEWCELL(s);
  CAR(s) = tc16_xmstring;
  CDR(s) = 0;
  return s;
}

SCM make_xmstringtable(len)
int len;
{
  SCM v;
  XmString *p;

  NEWCELL(v);
  DEFER_INTS;
  SET_XMSTRINGTABLE_LENGTH(v,len,tc16_xmstringtable);
  SETCHARS(v,must_malloc(len*sizeof(XmString),"make_xmstringtable"));
  p = (XmString *) CDR(v);
  while(--len>=0)
    p[len] = 0;
  ALLOW_INTS;
  return v;
}

static sizet xm_free_xmstring(ptr)
SCM ptr;
{
  sizet n = XmStringLength(XMSTRING(ptr));
  XmStringFree(XMSTRING(ptr));
  return n;
}

static sizet xm_free_xmstringtable(ptr)
SCM ptr;
{
  int i;
  sizet n = 0;
  XmString *p = (XmString *) CDR(ptr);

  for (i = 0; i < XMSTRINGTABLE_LENGTH(ptr); i++) {
    n += XmStringLength(p[i]);
    XmStringFree(p[i]);
  }
  return n;
}

SCM xm_text_get_string(sw)
SCM sw;
{
  char *p;
  SCM s;

  ASSERT(NIMP(sw) && WIDGETP(sw),sw,ARG1,s_xm_text_get_string);
  p = XmTextGetString(WIDGET(sw));
  if (!p) p = "";			/* p could be null here */
  s = makfromstr(p, strlen(p));
  XtFree(p);
  return s;
}


SCM xm_create_popup_menu(sparent, sname, args)
SCM sparent, sname, args;
{
  char *name;
  ArgList arglist;
  int n;
  Widget w;

  ASSERT(NIMP(sparent) && WIDGETP(sparent), sparent, ARG1, s_xm_create_popup_menu);
  ASSERT(NIMP(sname) && STRINGP(sname), sname, ARG2, s_xm_create_popup_menu);
  name = CHARS(sname);
  xt__make_arglist(args, &arglist, &n, s_xm_create_popup_menu);

  w = XmCreatePopupMenu(WIDGET(sparent), name, arglist, n);

  return make_widget(w);
}


SCM xm_create_pulldown_menu(sparent, sname, args)
SCM sparent, sname, args;
{
  char *name;
  ArgList arglist;
  int n;
  Widget w;
  SCM sw;

  ASSERT(NIMP(sparent) && WIDGETP(sparent), sparent, ARG1, s_xm_create_pulldown_menu);
  ASSERT(NIMP(sname) && STRINGP(sname), sname, ARG2, s_xm_create_pulldown_menu);
  name = CHARS(sname);
  xt__make_arglist(args, &arglist, &n, s_xm_create_pulldown_menu);

  w = XmCreatePulldownMenu(WIDGET(sparent), name, arglist, n);

  return make_widget(w);
}


SCM xm_list_delete_item(sw, ss)
SCM sw, ss;
{
  ASSERT(NIMP(sw) && WIDGETP(sw), sw, ARG1, s_xm_list_delete_item);
  ASSERT(NIMP(ss) && XMSTRINGP(ss), ss, ARG2, s_xm_list_delete_item);
  XmListDeleteItem(WIDGET(sw), XMSTRING(ss));
}


SCM xm_list_deselect_all_items(sw, ss)
SCM sw, ss;
{
  ASSERT(NIMP(sw) && WIDGETP(sw), sw, ARG1, s_xm_list_deselect_all_items);
  XmListDeselectAllItems(WIDGET(sw));
}

#ifdef SUPER_MOTIF
SCM xm_list_get_selected_pos(sw)
SCM sw;
{
  int i, j, *pos;
  SCM list;

  ASSERT(NIMP(sw) && WIDGETP(sw), sw, ARG1, s_xm_list_get_selected_pos);
  XmListGetSelectedPos(WIDGET(sw), &pos, &i);
  list = EOL;
  for (j = i-1; j >=0; j--)
    list = cons(MAKINUM((long)pos[j]), list);
  return list;
}

SCM xm_list_delete_all_items(sw)
SCM sw;
{
  ASSERT(NIMP(sw) && WIDGETP(sw), sw, ARG1, s_xm_list_delete_all_items);
  XmListDeleteAllItems(WIDGET(sw));
  return UNSPECIFIED;
}

/* if pos is bigger than number of items, just append at the end */
SCM xm_list_add_item(sw, str, pos)
SCM sw, str, pos;
{
  Widget w;
  int n;

  ASSERT(NIMP(sw) && WIDGETP(sw), sw, ARG1, s_xm_list_add_item);
  ASSERT(NIMP(str) && XMSTRINGP(str), str, ARG2, s_xm_list_add_item);
  ASSERT(INUMP(pos) && INUM(pos) >= 0, pos, ARG3, s_xm_list_add_item);

  w = WIDGET(sw);
  XtVaGetValues(w, XmNitemCount, &n, NULL);
  XmListAddItem(w, XMSTRING(str), INUM(pos) >= n ? 0 : INUM(pos));
  return UNSPECIFIED;
}

SCM xm_list_add_items(sw, stab, args)
SCM sw, stab, args;
{
  SCM count, pos;
  int max;
  char msg[64];

  ASSERT(NIMP(sw) && WIDGETP(sw), sw, ARG1, s_xm_list_add_items);
  ASSERT(NIMP(stab) && XMSTRINGTABLEP(stab), stab, ARG2, s_xm_list_add_items);

  max = XMSTRINGTABLE_LENGTH(XMSTRINGTABLE(stab));
  sprintf(msg, "ARG3: Maximum is %d", max);
  ASRTARG(count, args, ARG3, s_xm_list_add_items);
  ASSERT(INUMP(count) && INUM(count)>0 && INUM(count)<=max, count,
	 msg, s_xm_list_add_items);

  XtVaGetValues(WIDGET(sw), XmNitemCount, &max, NULL);
  sprintf(msg, "ARG4: Maximum is %d", max);
  ASRTARG(pos, args, ARG4, s_xm_list_add_items);
  ASSERT(INUMP(pos) && INUM(pos)>=0 && INUM(pos)<=max, pos,
	 msg, s_xm_list_add_items);

  XmListAddItems(WIDGET(sw), XMSTRINGTABLE(stab), INUM(count), INUM(pos));
  return UNSPECIFIED;
}

SCM xm_list_delete_items_pos(sw, scount, spos)
SCM sw, scount, spos;
{
  int max, count, pos;

  ASSERT(NIMP(sw) && WIDGETP(sw), sw, ARG1, s_xm_list_delete_items_pos);
  ASSERT(INUMP(scount), scount, ARG2, s_xm_list_delete_items_pos);
  ASSERT(INUMP(spos), spos, ARG3, s_xm_list_delete_items_pos);

  XtVaGetValues(WIDGET(sw), XmNitemCount, &max, NULL);
  count = INUM(scount);
  pos   = INUM(spos);

  ASSERT(count > 0 && count <= max - pos + 1, scount, 
	 "ARG2: count out of range", s_xm_list_delete_items_pos);
  ASSERT(pos > 0 && pos <= max, spos, 
	 "ARG3: position out of range", s_xm_list_delete_items_pos);
  XmListDeleteItemsPos(WIDGET(sw), count, pos);
  return UNSPECIFIED;
}

SCM xm_list_select_item(sw, xmstr, notify)
SCM sw, xmstr, notify;
{
  ASSERT(NIMP(sw) && WIDGETP(sw), sw, ARG1, s_xm_list_select_item);
  ASSERT(NIMP(xmstr) && XMSTRINGP(xmstr), xmstr, ARG2, s_xm_list_select_item);
  ASSERT(notify == BOOL_T || notify == BOOL_F, notify, ARG3, 
	 s_xm_list_select_item);
  XmListSelectItem(WIDGET(sw), XMSTRING(xmstr), (notify==BOOL_T)?True:False);
  return UNSPECIFIED;
}

SCM xm_list_select_pos(sw, pos, notify)
SCM sw, pos, notify;
{
  ASSERT(NIMP(sw) && WIDGETP(sw), sw, ARG1, s_xm_list_select_pos);
  ASSERT(INUMP(pos), pos, ARG2, s_xm_list_select_pos);
  ASSERT(notify == BOOL_T || notify == BOOL_F, notify, ARG3, 
	 s_xm_list_select_pos);
  XmListSelectPos(WIDGET(sw), INUM(pos), (notify==BOOL_T)? True:False);
  return UNSPECIFIED;
}

SCM xm_list_replace_items_pos(sw, sv, pos)
SCM sw, sv, pos;
{
  int max;

  ASSERT(NIMP(sw) && WIDGETP(sw), sw, ARG1, s_xm_list_replace_items_pos);
  ASSERT(NIMP(sv) && XMSTRINGTABLEP(sv), sv, ARG2, 
	 s_xm_list_replace_items_pos);
  ASSERT(INUMP(pos), pos, ARG3, s_xm_list_replace_items_pos);

  XtVaGetValues(WIDGET(sw), XmNitemCount, &max, NULL);
  ASSERT(INUM(pos) > 0 && INUM(pos) <= max, pos, "List pos out of range",
	 s_xm_list_replace_items_pos);

  XmListReplaceItemsPos(WIDGET(sw), XMSTRINGTABLE(sv), 
			XMSTRINGTABLE_LENGTH(sv), 
			INUM(pos));

  return UNSPECIFIED;
}

SCM xm_text_set_string(sw, text)
SCM sw, text;
{
  ASSERT(NIMP(sw) && WIDGETP(sw), sw, ARG1, s_xm_text_set_string);
  ASSERT(NIMP(text) && STRINGP(text), text, ARG2, s_xm_text_set_string);
  XmTextSetString(WIDGET(sw), CHARS(text));
  return UNSPECIFIED;
}

SCM xm_x_text_get_position(sw, opt)
SCM sw, opt;
{
  ASSERT(NIMP(sw) && WIDGETP(sw), sw, ARG1, s_xm_x_text_get_position);
  ASSERT(BOOLP(opt), opt, ARG2, s_xm_x_text_get_position);
  return ulong2num(opt == BOOL_T
		   ? XmTextGetInsertionPosition(WIDGET(sw)) 
		   : XmTextGetLastPosition(WIDGET(sw)));
}

SCM xm_text_insert(sw, pos, str)
SCM sw, pos, str;
{
  ASSERT(NIMP(sw) && WIDGETP(sw), sw, ARG1, s_xm_text_insert);
  ASSERT(INUMP(pos), pos, ARG2, s_xm_text_insert);
  ASSERT(NIMP(str) && STRINGP(str), str, ARG3, s_xm_text_insert);
#ifndef RECKLESS
  { 
      XmTextPosition p = XmTextGetLastPosition(WIDGET(sw));
      ASSERT(INUM(pos) >= 0 && INUM(pos) <= p, pos, ARG2, s_xm_text_insert);
  }
#endif
  XmTextInsert(WIDGET(sw), INUM(pos), CHARS(str));

  return UNSPECIFIED;
}

SCM xm_text_do_position(sw, pos, opt)
SCM sw, pos, opt;
{
  ASSERT(NIMP(sw) && WIDGETP(sw), sw, ARG1, s_xm_text_do_position);
  ASSERT(INUMP(pos), pos, ARG2, s_xm_text_do_position);
  ASSERT(INUMP(opt), opt, ARG3, s_xm_text_do_position);
  switch (INUM(opt))
  {
  case 0:
      XmTextSetInsertionPosition(WIDGET(sw), (XmTextPosition)INUM(pos));
      break;
  case 1:
      XmTextShowPosition(WIDGET(sw), (XmTextPosition)INUM(pos));
      break;
  case 2:
      XmTextScroll(WIDGET(sw), INUM(pos));
      break;
  default:
      wta(opt, "Option out of range(must be 1-3)", s_xm_text_do_position);
  }
  return UNSPECIFIED;
}

SCM xm_text_replace(sw, from, args)
SCM sw, from, args;
{
  SCM to, str;

  ASSERT(NIMP(sw) && WIDGETP(sw), sw, ARG1, s_xm_text_replace);
  ASSERT(INUMP(from), from, ARG2, s_xm_text_replace);
  ASRTARG(to, args, ARG3, s_xm_text_replace);
  ASSERT(INUMP(to), to, ARG3, s_xm_text_replace);
  ASRTARG(str, args, ARG4, s_xm_text_replace);
  ASSERT(NIMP(str) && STRINGP(str), str, ARG4, s_xm_text_replace);

  XmTextReplace(WIDGET(sw), 
		(XmTextPosition)INUM(from),
		(XmTextPosition)INUM(to),
		CHARS(str));
  return UNSPECIFIED;
}

SCM xm_text_find_string(sw, start, args)
SCM sw, start, args;
{
  SCM str, dir;
  XmTextPosition pos;

  ASSERT(NIMP(sw) && WIDGETP(sw), sw, ARG1, s_xm_text_find_string);
  ASSERT(INUMP(start), start, ARG2, s_xm_text_find_string);
  ASRTARG(str, args, ARG3, s_xm_text_find_string);
  ASSERT(NIMP(str) && STRINGP(str), str, ARG3, s_xm_text_find_string);
  ASRTARG(dir, args, ARG4, s_xm_text_find_string);
  ASSERT(BOOLP(dir), dir, ARG4, s_xm_text_find_string);
  if (XmTextFindString(WIDGET(sw), (XmTextPosition)INUM(start),
		       CHARS(str), 
		       dir == BOOL_T ? XmTEXT_FORWARD : XmTEXT_BACKWARD,
		       &pos))
      return ulong2num((unsigned long)pos);
  else
      return BOOL_F;
}

static SCM make_pixmap(Pixmap p)
{
    SCM v = make_xpixmap();
    SETCDR(v, p);
    return v;
}

SCM xm_get_pixmap(w, name, args)
SCM w, name, args;
{
  SCM fg, bg;
  Pixmap pix;

  ASSERT(NIMP(w) && WIDGETP(w), w, ARG1, s_xm_get_pixmap);
  ASSERT(NIMP(name) && STRINGP(name), w, ARG2, s_xm_get_pixmap);
  ASRTARG(fg, args, ARG3, s_xm_get_pixmap);
  ASSERT(INUMP(fg), fg, ARG3, s_xm_get_pixmap);
  ASRTARG(bg, args, ARG4, s_xm_get_pixmap);
  ASSERT(INUMP(bg), bg, ARG4, s_xm_get_pixmap);
  pix = XmGetPixmap(XtScreen(WIDGET(w)), CHARS(name), INUM(fg), INUM(bg));
  return (pix != XmUNSPECIFIED_PIXMAP) ? make_pixmap(pix) : BOOL_F;
}

SCM xm_get_pixmap_by_depth(w, name, args)
SCM w, name, args;
{
  SCM fg, bg, depth;
  Pixmap pix;

  ASSERT(NIMP(w) && WIDGETP(w), w, ARG1, s_xm_get_pixmap);
  ASSERT(NIMP(name) && STRINGP(name), w, ARG2, s_xm_get_pixmap);
  ASRTARG(fg, args, ARG3, s_xm_get_pixmap);
  ASSERT(INUMP(fg), fg, ARG3, s_xm_get_pixmap);
  ASRTARG(bg, args, ARG4, s_xm_get_pixmap);
  ASSERT(INUMP(bg), bg, ARG4, s_xm_get_pixmap);
  ASRTARG(depth, args, ARG5, s_xm_get_pixmap);
  ASSERT(INUMP(depth), depth, ARG5, s_xm_get_pixmap);
  pix = XmGetPixmapByDepth(XtScreen(WIDGET(w)), CHARS(name),
			   INUM(fg), INUM(bg), INUM(depth));
  return (pix != XmUNSPECIFIED_PIXMAP) ? make_pixmap(pix) : BOOL_F;
}

SCM xm_destroy_pixmap(w, p)
SCM w, p;
{
  ASSERT(NIMP(w) && WIDGETP(w), w, ARG1, s_xm_destroy_pixmap);
  ASSERT(NIMP(p) && XPIXMAPP(p), p, ARG2, s_xm_destroy_pixmap);
  return VALBOOL(XmDestroyPixmap(XtScreen(WIDGET(w)), XPIXMAP(p)));
}
#endif

SCM xm_menu_position(sw, se)
SCM sw, se;
{
  XButtonPressedEvent *e;

  ASSERT(NIMP(sw) && WIDGETP(sw), sw, ARG1, s_xm_menu_position);
  ASSERT(NIMP(se) && XEVENTP(se), se, ARG2, s_xm_menu_position);
  e = (XButtonPressedEvent *) XEVENT(se);
  XmMenuPosition(WIDGET(sw), e);
  return UNSPECIFIED;
}


SCM xm_string_create(str)
SCM str;
{
  SCM s;

  ASSERT(NIMP(str) && STRINGP(str), str, ARG1, s_xm_string_create);
  s = make_xmstring();
#ifdef XMT
  SETCDR(s, XmtCreateXmString(CHARS(str)));
#else
  SETCDR(s, XmStringCreateLtoR(CHARS(str), XmSTRING_DEFAULT_CHARSET));
#endif

  return s;
}


SCM xm_xmstringp(x)
SCM x;
{
  if (NIMP(x) && XMSTRINGP(x))
    return BOOL_T;
  else
    return BOOL_F;
}


SCM xm_xmstringtablep(x)
SCM x;
{
  if (NIMP(x) && XMSTRINGTABLEP(x))
    return BOOL_T;
  else
    return BOOL_F;
}


SCM xm_string_get_first_segment(sstr)
SCM sstr;
{
  XmString str;
  char *p;
  SCM s;

  ASSERT(NIMP(sstr) && XMSTRINGP(sstr), sstr, ARG1, s_xm_string_get_first_segment);
  XmStringGetLtoR(XMSTRING(sstr), XmSTRING_DEFAULT_CHARSET, &p);
  s = makfromstr(p, strlen(p));
  return s;
}


SCM xm_xmstringtable_to_vector(sl)
SCM sl;
{
  int i, len;
  SCM v, s;

  ASSERT(NIMP(sl) && XMSTRINGTABLEP(sl), sl, ARG1, s_xm_xmstringtable_to_vector);
  len = XMSTRINGTABLE_LENGTH(sl);
  if (len == 0) return nullvect;
  v = make_vector(MAKINUM((long) len), UNDEFINED);
  for (i = 0; i < len; i++) {
    s = make_xmstring();
    SETCDR(s, XmStringCopy(XMSTRINGTABLE(sl)[i]));
    VELTS(v)[i] = s;
  }
  return v;
}

SCM xm_vector_to_xmstringtable(sv)
SCM sv;
{
  SCM sl, s;
  int i, len;
  XmStringTable p;

  ASSERT(NIMP(sv) && VECTORP(sv), sv, ARG1, s_xm_vector_to_xmstringtable);
  len = LENGTH(sv);
  sl = make_xmstringtable(len);
  p = XMSTRINGTABLE(sl);
  for (i = 0; i < len; i++) {
    s = VELTS(sv)[i];
    ASSERT(NIMP(s) && XMSTRINGP(s), s, "vector elements must be XmStrings", s_xm_vector_to_xmstringtable);
    p[i] = XmStringCopy(XMSTRING(s));
  }
  return sl;  
}


static int print_xmstring(exp, f, writing)
SCM exp;
SCM f;
int writing;
{
  lputs("#<XmString>", f);
  return 1;
}

static int print_xmstringtable(exp, f, writing)
SCM exp;
SCM f;
int writing;
{
  lputs("#<XmStringTable of ", f);
  intprint(XMSTRINGTABLE_LENGTH(exp), 10, f);
  lputc('>',f);
  return 1;
}

iproc xm_subr3s[] = {
#ifdef SUPER_MOTIF
  {s_xm_list_add_item,          xm_list_add_item},
  {s_xm_list_delete_items_pos,  xm_list_delete_items_pos},
  {s_xm_list_select_item,       xm_list_select_item},
  {s_xm_list_select_pos,        xm_list_select_pos},
  {s_xm_list_replace_items_pos, xm_list_replace_items_pos},
  {s_xm_text_insert,            xm_text_insert},
  {s_xm_text_do_position,       xm_text_do_position},
#endif
  {0,0}
};

iproc xm_lsubr2s[] = {
  {s_xm_create_popup_menu,	xm_create_popup_menu},
  {s_xm_create_pulldown_menu,	xm_create_pulldown_menu},
#ifdef SUPER_MOTIF
  {s_xm_list_add_items,         xm_list_add_items},
  {s_xm_text_replace,           xm_text_replace},
  {s_xm_text_find_string,       xm_text_find_string},
  {s_xm_get_pixmap,		xm_get_pixmap},
  {s_xm_get_pixmap_by_depth,	xm_get_pixmap_by_depth},
#endif
  {0, 0}
};

iproc xm_subr2s[] = {
  {s_xm_list_delete_item,		xm_list_delete_item},
  {s_xm_menu_position,			xm_menu_position},
  {s_xm_process_traversal,		xm_process_traversal},
#ifdef SUPER_MOTIF
  {s_xm_text_set_string,                xm_text_set_string},
  {s_xm_x_text_get_position,            xm_x_text_get_position},
#endif
  {0, 0}
};

iproc xm_subr1s[] = {
#ifdef SUPER_MOTIF
  {s_xm_list_get_selected_pos,		xm_list_get_selected_pos},
  {s_xm_list_delete_all_items,          xm_list_delete_all_items},
  {s_xm_destroy_pixmap,			xm_destroy_pixmap},
#endif
  {s_xm_list_deselect_all_items,	xm_list_deselect_all_items},
  {s_xm_string_create,			xm_string_create},
  {s_xm_string_get_first_segment,	xm_string_get_first_segment},
  {s_xm_text_get_string,		xm_text_get_string},
  {s_xm_xmstringp,			xm_xmstringp},
  {s_xm_xmstringtablep,			xm_xmstringtablep},
  {s_xm_xmstringtable_to_vector,	xm_xmstringtable_to_vector},
  {s_xm_vector_to_xmstringtable,	xm_vector_to_xmstringtable},
  {0, 0}
};

#undef XX
#define XX(name, mark, free) \
    TOKEN_PASTE(tc16_,name) = newsmob(&TOKEN_PASTE(smob,name));

void init_xm()
{
  x_make_integer_constants(xm_symbols);
  init_iprocs(xm_lsubr2s, tc7_lsubr_2);
  init_iprocs(xm_subr2s,  tc7_subr_2);
  init_iprocs(xm_subr1s,  tc7_subr_1);
#ifdef SUPER_MOTIF
  init_iprocs(xm_subr3s,  tc7_subr_3);
#endif
  XM_SMOBS
  xt_init_widget_classes(
    xm_widget_classes,
    XtNumber(xm_widget_classes),
    "*motif-widget-classes*");
#ifdef CDE
  init_cde();
#endif
#ifdef HTML_WIDGET
  init_html();
#endif
}
