;;; Motif Support.
;;; Copyright 1995 by Thomas Kwong (tomkwong@wilshire.com)
;;;
;;; All resource constants, which are now being generated automatically
;;; from a Perl script, have been moved to xmconst.scm.  This file now
;;; defines constants such as enum's.  Here also defines wrappers to
;;; the xmscm motif interface.
;;;
;;; $Id: xm.scm,v 1.1 1995/12/06 23:06:40 tomkwong Exp $

;; Hooks to xmscm core functions.

(define (xm:scale-set-value w v) (xt:set-values w xm:n-value v))
(define (xm:scale-get-value w v) (xt:get-values w xm:n-value xt:integer))

(define (xm:text-set-insertion-position w pos) (xm:x-text-do-position w pos 0))
(define (xm:text-show-position w pos)          (xm:x-text-do-position w pos 1))
(define (xm:text-scroll w pos)                 (xm:x-text-do-position w pos 2))
(define (xm:text-get-insertion-position w)     (xm:x-text-get-position w #t))
(define (xm:text-get-last-position w)          (xm:x-text-get-position w #f))

;; Convenience Functions

(define (xm:create-work-area parent name . args)
  (apply xt:create-widget
	 (append (list name xm:row-column parent
		       xm:n-row-column-type xm:work-area)
		 args)))

;; Accessing callback data.

; These are generic.
(define (xm:callback-reason data) (vector-ref data 0))
(define (xm:callback-event  data) (vector-ref data 1))

; The followings are widget dependent.
(define (xm:text:curr-insert data) (vector-ref data 2))
(define (xm:text:new-insert  data) (vector-ref data 3))
(define (xm:text:start-pos   data) (vector-ref data 4))
(define (xm:text:end-pos     data) (vector-ref data 5))
(define (xm:text:text        data) (vector-ref data 6))
(define (xm:text:text-format data) (vector-ref data 7))

(define (xm:list:item                data) (vector-ref data 2))
(define (xm:list:item-length         data) (vector-ref data 3))
(define (xm:list:item-position       data) (vector-ref data 4))
(define (xm:list:selected-item-count data) (vector-ref data 5))
(define (xm:list:selection-type      data) (vector-ref data 6))

(define (xm:push-button:click-count data) (vector-ref data 2))

(define (xm:toggle-button:set data)       (vector-ref data 2))

(define (xm:scale:value data) (vector-ref data 2))

(define (xm:scroll-bar:value data) (vector-ref data 2))
(define (xm:scroll-bar:pixel data) (vector-ref data 3))

(define (xm:selection-box:value  data) (vector-ref data 2))
(define (xm:selection-box:length data) (vector-ref data 3))

