;;; Xmt Interface Definitions
;;; Copyright 1995 by Thomas Kwong (tomkwong@wilshire.com)
;;;
;;; All resource constants, which are now being generated automatically
;;; from a Perl script, have been moved to xmtconst.scm.  This file now
;;; defines constants such as enum's.  It also defines some wrappers
;;; to the internal Xmtscm C interface.
;;;
;;; $Id: xmt.scm,v 1.1 1995/12/06 23:09:17 tomkwong Exp $

(define xmt:error-message       1)
(define xmt:warning-message     2)
(define xmt:information-message 3)

(define xmt:image-field:width       0)
(define xmt:image-field:height      1)
(define xmt:image-field:hotspot     2)
(define xmt:image-field:has_hotspot 3)
(define xmt:image-field:ncolors     4)
(define xmt:image-field:data        5)

(define xmt:msg-line-now       #t)
(define xmt:msg-line-on-action #f)
(define xmt:msg-line-string   0)
(define xmt:msg-line-char     1)
(define xmt:msg-line-unsigned 2)
(define xmt:msg-line-int      3)
(define xmt:msg-line-double   4)

;;; Chooser
(define (xmt:get-chooser-state chooser)
  (xt:get-value chooser xmt:n-state xt:integer))

(define (xmt:set-chooser-state chooser mask)
  (xt:set-values chooser "state" mask))

;;; MsgLine
(define (xmt:msg-line-get-string   msgline) (xmt:msg-line-get msgline 0))
(define (xmt:msg-line-get-char     msgline) (xmt:msg-line-get msgline 1))
(define (xmt:msg-line-get-unsigned msgline) (xmt:msg-line-get msgline 2))
(define (xmt:msg-line-get-int      msgline) (xmt:msg-line-get msgline 3))
(define (xmt:msg-line-get-double   msgline) (xmt:msg-line-get msgline 4))

;;; Getting shell widgets
(define (xmt:get-shell w)             (xmt:x-get-shell w 1))
(define (xmt:get-application-shell w) (xmt:x-get-shell w 2))
(define (xmt:get-toplevel-shell w)    (xmt:x-get-shell w 3))

;;; Cursors
(define (xmt:display-busy-cursor w)    (xmt:x-display-busy/default-cursor w #t))
(define (xmt:display-default-cursor w) (xmt:x-display-busy/default-cursor w #f))

;;; Pixmaps and Bitmaps
(define (xmt:get-pixmap w name) (xmt:x-get-bitmap/pixmap w name #t))
(define (xmt:get-bitmap w name) (xmt:x-get-bitmap/pixmap w name #f))

(define (xmt:create-pixmap-icon w pixmap shape)
  (xmt:x-create/change-pixmap-icon w pixmap shape #t))
(define (xmt:change-pixmap-icon w pixmap shape)
  (xmt:x-create/change-pixmap-icon w pixmap shape #f))

;;; Shell Manipulations
(define (xmt:iconify-shell   w) (xmt:x-manipulate-shell w 1))
(define (xmt:deiconify-shell w) (xmt:x-manipulate-shell w 2))
(define (xmt:raise-shell     w) (xmt:x-manipulate-shell w 3))
(define (xmt:lower-shell     w) (xmt:x-manipulate-shell w 4))

;;; Display Messages
(define (xmt:display-error-message w name . args)
  (apply xmt:display-message (append (list w name 1) args)))
(define (xmt:display-warning-message w name . args)
  (apply xmt:display-message (append (list w name 2) args)))
(define (xmt:display-information-message w name . args)
  (apply xmt:display-message (append (list w name 3) args)))
								
;;; WM 
(define (xmt:add-delete-callback w response proc . data)
  (xmt:x-add-wm-callback w #t response proc (if (null? data) #f (car data))))

(define (xmt:add-save-yourself-callback w proc . data)
  (xmt:x-add-wm-callback w #f #f proc (if (null? data) #f (car data))))

;;; Xmt
(define (xmt:layout-enable-layout w)  (xmt:x-layout-enable/disable w #t))
(define (xmt:layout-disable-layout w) (xmt:x-layout-enable/disable w #f))

